<?php

namespace Drupal\monarch_response_utility;

use Symfony\Component\HttpFoundation\Response;

/**
 * Use this exception to interrupt Drupal and return a response.
 *
 * This helps avoid issues with exit or die calls, while allowing Drupal to
 * terminate properly.
 */
class ResponseException extends \Exception {

  /**
   * The response headers.
   */
  protected array $headers;

  /**
   * Set the response details.
   */
  public function __construct(?string $content = '', int $status = 200, array $headers = []) {
    parent::__construct($content ?? '', $status);
    $this->headers = $headers;
  }

  /**
   * Build the response.
   */
  public function toResponse() : Response {
    return new Response($this->message, $this->code, $this->headers);
  }

}
